<app-header></app-header>

<div class="content ">
    <h2>Learning </h2>

    <form (ngSubmit)="getPrediction()">
        <fieldset>
            <legend>Get prediction</legend>
            <table>
                <tr>
                    <td><label for="initDay"  > Initial time : </label></td>
                    <td><input size="8" type="text"  name="initDay"  [(ngModel)]="initDay"></td>
                    <td><label for="initTime"  > </label></td>
                    <td><input size="5" type="text" name="initTime"  [(ngModel)]="initTime"></td>
                    <td><label for="targetDay">Target time : </label></td>
                    <td><input size="8" type="text" name="targetDay"  [(ngModel)]="targetDay"></td>
                    <td><label for="targetTime"> </label></td>
                    <td><input size="5" type="text" name="targetTime"  [(ngModel)]="targetTime"></td>
                    <td><label for="prediction_location">Location : </label></td>
                    <td>
                        <select [(ngModel)]="prediction_location"  name="prediction_location"     >
                            <option *ngFor="let location of listLocations" [value]="location.value">{{location.label}}</option>
                        </select>
                    </td>
                    <td>  &nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
                        <button class="btn btn-success" type="submit">prediction</button>
                    </td>
                </tr>
            </table>
        </fieldset>
    </form>

    <ng-container *ngIf="this.prediction.hasOwnProperty('mapLastResults')">
        <button id='btDisplayTimeSeps'  size="20"  (click)="displayTimeSteps();">Time steps :</button>
        <br>
        <span class='display_none' id='ngc_time_steps' >
            <ng-containter  *ngFor="let timeSlot of this.prediction['listTimeSlot'] ">
            <br> . {{formatTimeSlot(timeSlot)}}
            </ng-containter>
        </span>
        <br>
        <b>Prediction result : </b>
        <br>
        <table>
            <tr>
                <td></td>
                <td class='trans_matrix  matrix_hearder' [attr.colspan]="2">Initial state </td>
                <td class='trans_matrix  matrix_hearder' [attr.colspan]="0+this.stateNb"  ><b>Target state probabilities</b></td>
                <td class='trans_matrix  matrix_hearder'>Target state</td>
            </tr>
            <tr>
                <td></td>
                <td class='trans_matrix  matrix_hearder'>Value</td>
                <td class='trans_matrix  matrix_hearder'>State</td>
                <td *ngFor="let state of this.listStates;let idxState = index;" scope="row" class='trans_matrix  matrix_hearder' ><b>S{{idxState+1}}</b></td>
                <td class='trans_matrix  matrix_hearder'>State</td>
            </tr>
            <tr *ngFor="let predictionItem of this.prediction['mapLastResults'] | keyvalue ; let varIdx=index;" scope="row" class='states  states_hearder' >
                <td class='states  states_hearder'><b>{{predictionItem.key}}</b></td>
                <td class='trans_matrix  '>
                      {{fnum2(this.prediction['initialValues'][predictionItem.key])}}
                </td>
                <td class='trans_matrix  '>
                    S{{this.prediction['initialStates'][predictionItem.key]['id']}}
               </td>
                <td *ngFor="let value of predictionItem.value['stateProbabilities']; let idx=index;" scope="row" class='trans_matrix {{greyLevel(value, -1,-1)}}' >
                    <b>{{fnum3(value)}}</b>
                </td>
                <td class='trans_matrix  '>
                    S{{this.prediction['mapLastResults'][predictionItem.key]['radomTargetState']['id']}}
               </td>
            </tr>
        </table>
    </ng-container>

    <ng-container *ngIf="this.prediction.hasOwnProperty('errors')">
        <br/>
        <div *ngFor="let error of this.prediction['errors']" class='txt_warning_high' scope="row">
            <b>ERROR : {{error}}</b>
        </div>
    </ng-container>
<br>

Markov states :

<table>
    <tr>
        <td *ngFor="let state of this.listStates;let idxState = index;" scope="row" class='states  states_hearder' ><b>S{{idxState+1}}</b></td>
    </tr>
    <tr>
        <td *ngFor="let state of this.listStates;let idxState = index;" scope="row" class='states  ' ><b>{{state}}</b></td>
    </tr>
</table>
<br>


<form (ngSubmit)="refreshMatrices()">
    <fieldset>
        <table>
            <tr>
                <td><label for="filter_start_hour_min">min start hour :</label></td>
                <td><input size="3" type="text" id="filter_start_hour_min"  name="filter_start_hour_min"  [(ngModel)]="filter_start_hour_min"></td>
                <td><label for="filter_start_hour_max">max start hour :</label></td>
                <td><input size="3" type="text"  id="filter_start_hour_max"  name="filter_start_hour_max"  [(ngModel)]="filter_start_hour_max"></td>
                <td><label for="filter_location">Location :</label></td>
                <td>
                    <select [(ngModel)]="filter_location"  name="filter_location"     >
                        <option *ngFor="let location of listLocations" [value]="location.value">{{location.label}}</option>
                    </select>
                </td>
                <td>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;  <button class="btn btn-success" type="submit">Refresh</button></td>
            </tr>
        </table>
        <legend>All transition matrices</legend>
    </fieldset>
</form>




<br>
<table>
    <!-- liness of time windows-->
    <tr>
        <td *ngFor="let timeWindow of this.listTimeWindows" [attr.colspan]="1+this.stateNb" scope="row" class='trans_matrix  matrix_hearder next_bloc next_bloc2' >
            <b>Time window : {{timeWindow}}</b>
        </td>
    </tr>
    <ng-container *ngFor="let variableName of this.variables" scope="row">
        <!-- lines of states for each time window -->
        <tr>
            <ng-container *ngFor="let timeWindow of this.listTimeWindows"  >
                <td  class='trans_matrix matrix_hearder next_bloc next_bloc2'><b>{{variableName}}</b></td>
                <td *ngFor="let state of this.listStates;let idxState = index;"   class='trans_matrix matrix_hearder next_bloc2' >  
                    <b>S{{idxState+1}}</b>
                </td>
            </ng-container>
        </tr>
        <!-- lines of states for each result set  -->
        <tr *ngFor="let state of this.listStates;let idxState = index;" >
            <ng-container *ngFor="let timeWindow of this.listTimeWindows"  >
                <td  class='trans_matrix matrix_hearder next_bloc'>
                    <b>S{{idxState+1}}</b>
                    <!-- disaply the number of observations -->
                    <span class='matrix_info_small'>
                        ({{selectAllObsMatrixRowSum(variableName, timeWindow, idxState)}})
                    </span>
                </td>
                <td *ngFor="let item of this.selectNormalizedMatrixRow(variableName, timeWindow, idxState); let columnIdx = index;" scope="row" class='trans_matrix num  {{getNormalizedMatrixRowClass(variableName, timeWindow, idxState)}}  {{greyLevel(item, idxState, columnIdx)}}' >
                    {{fnum3(item)}}
                    <!-- disaply the number of observations -->
                    <span *ngIf="item > 0" class='matrix_info_small'>
                        ({{selectAllObsMatrixCell(variableName, timeWindow, idxState, columnIdx)}})
                    </span>
                </td>
            </ng-container>
        </tr>
        <tr>
            <td *ngFor="let timeWindow of this.listTimeWindows" [attr.colspan]="1+this.stateNb" scope="row" class='trans_matrix  next_bloc matrix_info' >
                 {{this.getNbOfObservations(variableName, timeWindow)}} observations
                 , {{this.getNbOfIterations(variableName, timeWindow)}} iterations
            </td>
        </tr>
    </ng-container>
</table>



<!--
<table>
    <tr>
        <td *ngFor="let timeWindow of this.listTimeWindows" scope="row" class=' main_table' >Time window : {{timeWindow}}</td>
    </tr>
    <tr>
        <td *ngFor="let timeWindow of this.listTimeWindows" scope="row" class=' main_table ' >

            <span *ngFor="let variableName of this.variables" scope="row">
                <table class='table_trans_matrix'>
                    <tr>
                        <td class='trans_matrix matrix_hearder'><b>{{variableName}}</b></td>
                        <td *ngFor="let row of this.mapHomeTransitionMatrices[timeWindow].statesList ;let rowIdx = index;" scope="row" class='trans_matrix  matrix_hearder' ><b>S{{rowIdx+1}}</b></td>
                    </tr>
                    <tr  *ngFor="let row of this.mapHomeTransitionMatrices[timeWindow].mapNormalizedMatrices[variableName].array ;let rowIdx = index;" scope="row">            
                        <td  class='trans_matrix matrix_hearder'>S{{rowIdx+1}}</td>
                        <td *ngFor="let item of row" scope="row" class='trans_matrix num' >{{fnum3(item)}}</td>
                    </tr>
                </table>
                <br/>
            </span>
        </td>
    </tr>
</table>
-->
